!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     #############################################################
      SUBROUTINE ALLOC_SURFEX(KMODEL)
!     #############################################################
!
!!    AUTHOR
!!    ------
!!	R. El Khatib   *Meteo France*	
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    04/2010
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
USE MODD_TEB_PAR, ONLY : NTEB_PATCH_MAX
USE MODD_AGRI_n,   ONLY : AGRI_ALLOC
USE MODD_CH_SNAP_n,   ONLY : CH_EMIS_SNAP_ALLOC
USE MODD_CH_EMIS_FIELD_n,   ONLY : CH_EMIS_FIELD_ALLOC
USE MODD_CH_ISBA_n,   ONLY : CH_ISBA_ALLOC
USE MODD_CH_SEAFLUX_n,   ONLY : CH_SEAFLUX_ALLOC
USE MODD_CH_SURF_n,   ONLY : CH_SURF_ALLOC
USE MODD_CH_TEB_n,   ONLY : CH_TEB_ALLOC
USE MODD_CH_WATFLUX_n,   ONLY : CH_WATFLUX_ALLOC
USE MODD_DATA_ISBA_n,   ONLY : DATA_ISBA_ALLOC
USE MODD_DATA_TSZ0_n,   ONLY : DATA_TSZ0_ALLOC
USE MODD_DATA_SEAFLUX_n,   ONLY : DATA_SEAFLUX_ALLOC
USE MODD_DATA_TEB_GARDEN_n,   ONLY : DATA_TEB_GARDEN_ALLOC
USE MODD_DATA_TEB_n,   ONLY : DATA_TEB_ALLOC
USE MODD_BLD_DESCRIPTION,   ONLY : BLD_DESC_ALLOC
USE MODD_DATA_BEM_n,   ONLY : DATA_BEM_ALLOC
USE MODD_DATA_TEB_GREENROOF_n,   ONLY : DATA_TEB_GREENROOF_ALLOC
USE MODD_DIAG_EVAP_ISBA_n,   ONLY : DIAG_EVAP_ISBA_ALLOC
USE MODD_DIAG_FLAKE_n,   ONLY : DIAG_FLAKE_ALLOC
USE MODD_DIAG_IDEAL_n,   ONLY : DIAG_IDEAL_ALLOC
USE MODD_DIAG_ISBA_n,   ONLY : DIAG_ISBA_ALLOC
USE MODD_DIAG_MISC_FLAKE_n,   ONLY : DIAG_MISC_FLAKE_ALLOC
USE MODD_DIAG_MISC_ISBA_n,   ONLY : DIAG_MISC_ISBA_ALLOC
USE MODD_DIAG_MISC_TEB_n,   ONLY : DIAG_MISC_TEB_ALLOC, DIAG_MISC_TEB_OPTIONS_ALLOC
USE MODD_DIAG_UTCI_TEB_n,   ONLY : DIAG_UTCI_TEB_ALLOC
USE MODD_DIAG_OCEAN_n,   ONLY : DIAG_OCEAN_ALLOC
USE MODD_DIAG_SEAFLUX_n,   ONLY : DIAG_SEAFLUX_ALLOC
USE MODD_DIAG_SURF_ATM_n,   ONLY : DIAG_SURF_ATM_ALLOC
USE MODD_DIAG_TEB_n,   ONLY : DIAG_TEB_ALLOC
USE MODD_DIAG_WATFLUX_n,   ONLY : DIAG_WATFLUX_ALLOC
USE MODD_DST_n,   ONLY : DST_ALLOC
USE MODD_DUMMY_SURF_FIELDS_n,   ONLY : DUMMY_SURF_FIELDS_ALLOC
USE MODD_EMIS_GR_FIELD_n,   ONLY : EMIS_GR_FIELD_ALLOC
USE MODD_FLAKE_GRID_n,   ONLY : FLAKE_GRID_ALLOC
USE MODD_FLAKE_n,   ONLY : FLAKE_ALLOC
USE MODD_FLAKE_SBL_n,   ONLY : FLAKE_SBL_ALLOC
USE MODD_GR_BIOG_GARDEN_n,   ONLY : GR_BIOG_GARDEN_ALLOC
USE MODD_GR_BIOG_n,   ONLY : GR_BIOG_ALLOC
USE MODD_IDEAL_n,   ONLY : IDEAL_ALLOC
USE MODD_IO_BUFF_n,   ONLY : IO_BUFF_ALLOC
USE MODD_ISBA_CANOPY_n,   ONLY : ISBA_CANOPY_ALLOC
USE MODD_ISBA_GRID_n,   ONLY : ISBA_GRID_ALLOC
USE MODD_ISBA_n,   ONLY : ISBA_ALLOC
USE MODD_OCEAN_GRID_n,   ONLY : OCEAN_GRID_ALLOC
USE MODD_OCEAN_n,   ONLY : OCEAN_ALLOC
USE MODD_OCEAN_REL_n,   ONLY : OCEAN_REL_ALLOC
USE MODD_SEAFLUX_GRID_n,   ONLY : SEAFLUX_GRID_ALLOC
USE MODD_SEAFLUX_n,   ONLY : SEAFLUX_ALLOC
USE MODD_SEAFLUX_SBL_n,   ONLY : SEAFLUX_SBL_ALLOC
USE MODD_SLT_n,   ONLY : SLT_ALLOC
USE MODD_SURF_ATM_GRID_n,   ONLY : SURF_ATM_GRID_ALLOC
USE MODD_SURF_ATM_n,   ONLY : SURF_ATM_ALLOC
USE MODD_SURF_ATM_SSO_n,   ONLY : SURF_ATM_SSO_ALLOC
USE MODD_DATA_COVER_n,   ONLY : DATA_COVER_ALLOC
USE MODD_SV_n,   ONLY : SV_ALLOC
USE MODD_SSO_CANOPY_n,   ONLY : SSO_CANOPY_ALLOC
USE MODD_TEB_CANOPY_n,   ONLY : TEB_CANOPY_ALLOC
USE MODD_TEB_GARDEN_n,   ONLY : TEB_GARDEN_ALLOC, TEB_GARDEN_OPTIONS_ALLOC, &
                                TEB_GARDEN_PGD_ALLOC, TEB_GARDEN_PGD_EVOL_ALLOC
USE MODD_TEB_GRID_n,   ONLY : TEB_GRID_ALLOC
USE MODD_TEB_n,   ONLY : TEB_ALLOC, TEB_OPTIONS_ALLOC
USE MODD_TEB_VEG_n,   ONLY : TEB_VEG_OPTIONS_ALLOC
USE MODD_BEM_n,   ONLY : BEM_ALLOC, BEM_OPTIONS_ALLOC
USE MODD_TEB_GREENROOF_n,   ONLY : TEB_GREENROOF_OPTIONS_ALLOC,  &
                                   TEB_GREENROOF_PGD_ALLOC,      &
                                   TEB_GREENROOF_ALLOC,          &
                                   TEB_GREENROOF_PGD_EVOL_ALLOC
USE MODD_WATFLUX_GRID_n,   ONLY : WATFLUX_GRID_ALLOC
USE MODD_WATFLUX_n,   ONLY : WATFLUX_ALLOC
USE MODD_WATFLUX_SBL_n,   ONLY : WATFLUX_SBL_ALLOC
USE MODD_DIAG_TRIP_n,   ONLY : DIAG_TRIP_ALLOC
USE MODD_TRIP_GRID_n,   ONLY : TRIP_GRID_ALLOC
USE MODD_TRIP_n,   ONLY : TRIP_ALLOC
!
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
!*       0.1   Declarations of arguments
!              -------------------------
INTEGER, INTENT(IN) :: KMODEL    ! actual number of surfaces
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!
!*       0.2   Declarations of local variables
!              -------------------------------

!-------------------------------------------------------------------------------
!
IF (LHOOK) CALL DR_HOOK('ALLOC_SURFEX',0,ZHOOK_HANDLE)
 CALL AGRI_ALLOC(KMODEL)
 CALL CH_EMIS_FIELD_ALLOC(KMODEL)
 CALL CH_EMIS_SNAP_ALLOC(KMODEL)
 CALL CH_ISBA_ALLOC(KMODEL)
 CALL CH_SEAFLUX_ALLOC(KMODEL)
 CALL CH_SURF_ALLOC(KMODEL)
 CALL CH_TEB_ALLOC(KMODEL)
 CALL CH_WATFLUX_ALLOC(KMODEL)
 CALL DATA_ISBA_ALLOC(KMODEL)
 CALL DATA_TSZ0_ALLOC(KMODEL)
 CALL DATA_SEAFLUX_ALLOC(KMODEL)
 CALL DATA_TEB_GARDEN_ALLOC(KMODEL)
 CALL DATA_TEB_GREENROOF_ALLOC(KMODEL)
 CALL DATA_TEB_ALLOC(KMODEL)
 CALL DATA_BEM_ALLOC(KMODEL)
 CALL BLD_DESC_ALLOC(KMODEL)
 CALL DIAG_EVAP_ISBA_ALLOC(KMODEL)
 CALL DIAG_FLAKE_ALLOC(KMODEL)
 CALL DIAG_IDEAL_ALLOC(KMODEL)
 CALL DIAG_ISBA_ALLOC(KMODEL)
 CALL DIAG_MISC_FLAKE_ALLOC(KMODEL)
 CALL DIAG_MISC_ISBA_ALLOC(KMODEL)
 CALL DIAG_MISC_TEB_ALLOC(KMODEL,NTEB_PATCH_MAX)
 CALL DIAG_MISC_TEB_OPTIONS_ALLOC(KMODEL)
 CALL DIAG_UTCI_TEB_ALLOC(KMODEL)
 CALL DIAG_OCEAN_ALLOC(KMODEL)
 CALL DIAG_SEAFLUX_ALLOC(KMODEL)
 CALL DIAG_SURF_ATM_ALLOC(KMODEL)
 CALL DIAG_TEB_ALLOC(KMODEL)
 CALL DIAG_WATFLUX_ALLOC(KMODEL)
 CALL DST_ALLOC(KMODEL)
 CALL DUMMY_SURF_FIELDS_ALLOC(KMODEL)
 CALL EMIS_GR_FIELD_ALLOC(KMODEL)
 CALL FLAKE_GRID_ALLOC(KMODEL)
 CALL FLAKE_ALLOC(KMODEL)
 CALL FLAKE_SBL_ALLOC(KMODEL)
 CALL GR_BIOG_GARDEN_ALLOC(KMODEL)
 CALL GR_BIOG_ALLOC(KMODEL)
 CALL IDEAL_ALLOC(KMODEL)
 CALL IO_BUFF_ALLOC(KMODEL)
 CALL ISBA_CANOPY_ALLOC(KMODEL)
 CALL ISBA_GRID_ALLOC(KMODEL)
 CALL ISBA_ALLOC(KMODEL)
 CALL OCEAN_GRID_ALLOC(KMODEL)
 CALL OCEAN_ALLOC(KMODEL)
 CALL OCEAN_REL_ALLOC(KMODEL)
 CALL SEAFLUX_GRID_ALLOC(KMODEL)
 CALL SEAFLUX_ALLOC(KMODEL)
 CALL SEAFLUX_SBL_ALLOC(KMODEL)
 CALL SLT_ALLOC(KMODEL)
 CALL SURF_ATM_GRID_ALLOC(KMODEL)
 CALL SURF_ATM_ALLOC(KMODEL)
 CALL SURF_ATM_SSO_ALLOC(KMODEL)
 CALL DATA_COVER_ALLOC(KMODEL)
 CALL SV_ALLOC(KMODEL)
 CALL SSO_CANOPY_ALLOC(KMODEL)
 CALL TEB_CANOPY_ALLOC(KMODEL)
 CALL TEB_GARDEN_ALLOC(KMODEL,NTEB_PATCH_MAX)
 CALL TEB_GARDEN_OPTIONS_ALLOC(KMODEL)
 CALL TEB_GARDEN_PGD_EVOL_ALLOC(KMODEL,NTEB_PATCH_MAX)
 CALL TEB_GARDEN_PGD_ALLOC(KMODEL)
 CALL TEB_GRID_ALLOC(KMODEL)
 CALL TEB_ALLOC(KMODEL,NTEB_PATCH_MAX)
 CALL TEB_OPTIONS_ALLOC(KMODEL)
 CALL TEB_VEG_OPTIONS_ALLOC(KMODEL)
 CALL BEM_ALLOC(KMODEL,NTEB_PATCH_MAX)
 CALL BEM_OPTIONS_ALLOC(KMODEL)
 CALL TEB_GREENROOF_OPTIONS_ALLOC(KMODEL)
 CALL TEB_GREENROOF_PGD_ALLOC(KMODEL)
 CALL TEB_GREENROOF_PGD_EVOL_ALLOC(KMODEL,NTEB_PATCH_MAX)
 CALL TEB_GREENROOF_ALLOC(KMODEL,NTEB_PATCH_MAX)
 CALL WATFLUX_GRID_ALLOC(KMODEL)
 CALL WATFLUX_ALLOC(KMODEL)
 CALL WATFLUX_SBL_ALLOC(KMODEL)
 CALL DIAG_TRIP_ALLOC(KMODEL)
 CALL TRIP_GRID_ALLOC(KMODEL)
 CALL TRIP_ALLOC(KMODEL)
IF (LHOOK) CALL DR_HOOK('ALLOC_SURFEX',1,ZHOOK_HANDLE)
!
!-------------------------------------------------------------------------------
!
END SUBROUTINE ALLOC_SURFEX
