!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     #########
      SUBROUTINE CONVERT_PATCH_TEB(PCOVER,PDEF_ROAD_DIR,               &
                                   PZ0_TOWN,                           &
                                   PALB_ROOF,                          &
                                   PEMIS_ROOF,PHC_ROOF,PTC_ROOF,       &
                                   PD_ROOF,                            &
                                   PALB_ROAD,                          &
                                   PEMIS_ROAD,PHC_ROAD,PTC_ROAD,       &
                                   PD_ROAD,                            &
                                   PALB_WALL,                          &
                                   PEMIS_WALL,PHC_WALL,PTC_WALL,       &
                                   PD_WALL,                            &
                                   PBLD_HEIGHT,                        &
                                   PWALL_O_HOR,PBLD,                   &
                                   PGARDEN, PROAD_DIR,                 &
                                   PH_TRAFFIC,  PLE_TRAFFIC,           &
                                   PH_INDUSTRY, PLE_INDUSTRY,          &
                                   PHC_FLOOR, PTC_FLOOR, PD_FLOOR,     &
                                   PTCOOL_TARGET, PTHEAT_TARGET,       &
                                   PF_WASTE_CAN, PEFF_HEAT, PQIN,      &
                                   PQIN_FRAD, PSHGC, PU_WIN, PGR,      &
                                   PSHGC_SH, PFLOOR_HEIGHT, PINF,      &
                                   PF_WATER_COND, PQIN_FLAT,           &
                                   PHR_TARGET, PV_VENT, PCAP_SYS_HEAT, &
                                   PCAP_SYS_RAT, PT_ADP, PM_SYS_RAT,   &
                                   PCOP_RAT, PT_SIZE_MAX, PT_SIZE_MIN, &
                                   PSHADE, PNATVENT, PROUGH_ROOF,      &
                                   PROUGH_WALL, PGREENROOF             )
!     ##############################################################
!
!!**** *CONVERT_PATCH_TEB* compilation of conver_cover_isba, pgd_isba_par and
!!      init_from_data_isba_parn
!!
!!    PURPOSE
!!    -------
!!
!!    METHOD
!!    ------
!!   
!
!!    EXTERNAL
!!    --------
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!
!!    REFERENCE
!!    ---------
!!
!!    AUTHOR
!!    ------
!!
!!    S. Faroux        Meteo-France
!!
!!    MODIFICATION
!!    ------------
!!
!!    Original    16/11/10
!!    G. Pigeon     /09/12: add ROUGH_ROOF and ROUGH_WALL coef for outdoor conv. coef
!!
!----------------------------------------------------------------------------
!
!*    0.     DECLARATION
!            -----------
!
USE MODD_SURF_PAR,       ONLY : XUNDEF
!
USE MODD_DATA_COVER_n,   ONLY : XDATA_GARDEN, XDATA_BLD, XDATA_WALL_O_HOR
USE MODD_DATA_COVER_PAR, ONLY : NDATA_ROAD_LAYER, NDATA_WALL_LAYER,               &
                                NDATA_ROOF_LAYER, NDATA_FLOOR_LAYER
USE MODD_DATA_COVER,     ONLY : XDATA_Z0_TOWN, XDATA_ALB_ROOF,                    &
                                XDATA_EMIS_ROOF, XDATA_HC_ROOF, XDATA_TC_ROOF,    &
                                XDATA_D_ROOF, XDATA_ALB_ROAD, XDATA_EMIS_ROAD,    &
                                XDATA_HC_ROAD, XDATA_TC_ROAD, XDATA_D_ROAD,       &
                                XDATA_ALB_WALL, XDATA_EMIS_WALL, XDATA_HC_WALL,   &
                                XDATA_TC_WALL, XDATA_D_WALL, XDATA_BLD_HEIGHT,    &
                                XDATA_H_TRAFFIC, XDATA_LE_TRAFFIC,                &
                                XDATA_H_INDUSTRY, XDATA_LE_INDUSTRY,              &
                                XDATA_HC_FLOOR, XDATA_TC_FLOOR, XDATA_D_FLOOR,    &
                                XDATA_TCOOL_TARGET, XDATA_THEAT_TARGET,           &
                                XDATA_F_WASTE_CAN, XDATA_EFF_HEAT, XDATA_QIN,     &
                                XDATA_QIN_FRAD, XDATA_SHGC, XDATA_U_WIN, XDATA_GR,&
                                XDATA_SHGC_SH, XDATA_FLOOR_HEIGHT, XDATA_INF,     &
                                XDATA_F_WATER_COND, XDATA_QIN_FLAT,               &   
                                XDATA_HR_TARGET, XDATA_V_VENT, XDATA_CAP_SYS_HEAT,&
                                XDATA_CAP_SYS_RAT, XDATA_T_ADP, XDATA_M_SYS_RAT,  &
                                XDATA_COP_RAT, XDATA_T_SIZE_MAX, XDATA_T_SIZE_MIN,&
                                XDATA_SHADE, XDATA_NATVENT, XDATA_ROUGH_ROOF,     &
                              XDATA_ROUGH_WALL, XDATA_FRAC_GR
USE MODD_DATA_TEB_n
USE MODD_DATA_BEM_n
!
USE MODD_TEB_n,          ONLY : LGARDEN, CBLD_ATYPE
USE MODD_BLD_DESCRIPTION, ONLY : NDESC_ROOF_LAYER, NDESC_WALL_LAYER, &
                                 NDESC_ROAD_LAYER, NDESC_FLOOR_LAYER
!
USE MODI_THERMAL_LAYERS_CONF
USE MODI_INI_DATA_PARAM_TEB
USE MODI_AV_PGD
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
USE MODI_ABOR1_SFX
!
IMPLICIT NONE
!
!*    0.1    Declaration of arguments
!            ------------------------
!
REAL, DIMENSION(:,:),   INTENT(IN)    :: PCOVER
REAL,                   INTENT(IN)    :: PDEF_ROAD_DIR ! default road direction
!
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PZ0_TOWN
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PALB_ROOF
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PEMIS_ROOF
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL   :: PHC_ROOF
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL   :: PTC_ROOF
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL   :: PD_ROOF
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PALB_ROAD
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PEMIS_ROAD
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL   :: PHC_ROAD
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL   :: PTC_ROAD
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL   :: PD_ROAD
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PALB_WALL
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PEMIS_WALL
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL   :: PHC_WALL
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL   :: PTC_WALL
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL   :: PD_WALL
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PBLD_HEIGHT
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PWALL_O_HOR
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PBLD
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PGARDEN
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PROAD_DIR
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PH_TRAFFIC
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PLE_TRAFFIC
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PH_INDUSTRY
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PLE_INDUSTRY
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL   :: PHC_FLOOR
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL   :: PTC_FLOOR
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL   :: PD_FLOOR
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PTCOOL_TARGET
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PTHEAT_TARGET
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PF_WASTE_CAN
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PEFF_HEAT
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PQIN
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PQIN_FRAD
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PSHGC
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PU_WIN
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PGR
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PSHGC_SH
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PFLOOR_HEIGHT
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PINF
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PF_WATER_COND
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PQIN_FLAT
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PHR_TARGET
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PV_VENT
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PCAP_SYS_HEAT
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PCAP_SYS_RAT
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PT_ADP
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PM_SYS_RAT
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PCOP_RAT
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PT_SIZE_MAX
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PT_SIZE_MIN
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PSHADE
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PNATVENT
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PROUGH_ROOF
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PROUGH_WALL
REAL, DIMENSION(:),   INTENT(OUT), OPTIONAL   :: PGREENROOF
!
!*    0.2    Declaration of local variables
!            ------------------------------
!
REAL, DIMENSION(:,:), ALLOCATABLE :: ZTC, ZHC, ZD
INTEGER               :: JLAYER    ! loop counter on layers
INTEGER               :: IL        ! number of points
!
 CHARACTER(LEN=3)      :: YAVG      ! Type of averaging for buildings
 CHARACTER(LEN=4)      :: YAREA     ! Area where parameter is averaged
!
!*    0.3    Declaration of namelists
!            ------------------------
!
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!
!-------------------------------------------------------------------------------
!
!*    1.      Initializations
!             ---------------
!
IF (LHOOK) CALL DR_HOOK('CONVERT_PATCH_TEB',0,ZHOOK_HANDLE)
!
IF (CBLD_ATYPE=='ARI') THEN
  YAVG=CBLD_ATYPE
  YAREA='BLD'
ELSE
  YAVG=CBLD_ATYPE
  YAREA='BLV'
END IF
!
IL = SIZE(PCOVER,1)
!-------------------------------------------------------------------------------
!
!       ROAD DIRECTION 
!       --------------
IF (PRESENT(PROAD_DIR)) THEN
  IF (LDATA_ROAD_DIR) THEN
    PROAD_DIR=XPAR_ROAD_DIR
  ELSE
    PROAD_DIR=PDEF_ROAD_DIR
  ENDIF
ENDIF
!
!
!       GARDEN fraction
!       ---------------
IF (PRESENT(PGARDEN)) THEN
  IF (LDATA_GARDEN) THEN
    PGARDEN=XPAR_GARDEN
  ELSE
    CALL AV_PGD (PGARDEN, PCOVER, XDATA_GARDEN(:),'TWN','ARI')
  ENDIF
ENDIF
!
!
!       BLD fraction
!       -------------
IF (PRESENT(PBLD)) THEN
  IF (LDATA_BLD) THEN
    PBLD=XPAR_BLD  
  ELSE
    CALL AV_PGD (PBLD, PCOVER, XDATA_BLD(:),'TWN','ARI')
  ENDIF
ENDIF
!
!
!      Z0_TOWN
!      ----------
IF (PRESENT(PZ0_TOWN)) THEN 
  IF (LDATA_Z0_TOWN) THEN
    PZ0_TOWN=XPAR_Z0_TOWN  
  ELSE
    CALL AV_PGD (PZ0_TOWN ,PCOVER ,XDATA_Z0_TOWN (:),'TWN','CDN')  
  ENDIF  
ENDIF
!
!      BLD Height
!      ----------
IF (PRESENT(PBLD_HEIGHT)) THEN 
  IF (LDATA_BLD_HEIGHT) THEN
    PBLD_HEIGHT=XPAR_BLD_HEIGHT
  ELSE
    CALL AV_PGD (PBLD_HEIGHT ,PCOVER ,XDATA_BLD_HEIGHT (:),'BLD','ARI')  
  ENDIF  
ENDIF
!
!      WALL O HOR
!      ----------
IF (PRESENT(PWALL_O_HOR)) THEN
  IF (LDATA_WALL_O_HOR) THEN
    PWALL_O_HOR=XPAR_WALL_O_HOR 
  ELSE
    CALL AV_PGD (PWALL_O_HOR ,PCOVER ,XDATA_WALL_O_HOR (:),'BLD','ARI')  
  ENDIF  
ENDIF
!
!      ALB_ROOF
!      ----------
IF (PRESENT(PALB_ROOF)) THEN 
  IF (LDATA_ALB_ROOF) THEN
    PALB_ROOF=XPAR_ALB_ROOF
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PALB_ROOF=PALB_ROOF)
  ELSE
    CALL AV_PGD (PALB_ROOF ,PCOVER ,XDATA_ALB_ROOF (:),YAREA,YAVG)  
  ENDIF  
ENDIF
!
!      EMIS_ROOF
!      ----------
IF (PRESENT(PEMIS_ROOF)) THEN 
  IF (LDATA_EMIS_ROOF) THEN
    PEMIS_ROOF=XPAR_EMIS_ROOF
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PEMIS_ROOF=PEMIS_ROOF)
  ELSE
    CALL AV_PGD (PEMIS_ROOF ,PCOVER ,XDATA_EMIS_ROOF (:),YAREA,YAVG)  
  ENDIF  
ENDIF
!
!      HC_ROOF, TC_ROOF, D_ROOF
!      ------------------------
!
IF (PRESENT(PHC_ROOF) .AND. PRESENT(PTC_ROOF) .AND. PRESENT(PD_ROOF)) THEN
  IF (LDATA_HC_ROOF) THEN
    CALL ALLOCATE_THERMAL_WORK(NPAR_ROOF_LAYER)
    ZHC=XPAR_HC_ROOF
    ZTC=XPAR_TC_ROOF
    ZD =XPAR_D_ROOF
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL ALLOCATE_THERMAL_WORK(NDESC_ROOF_LAYER)
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PHC_ROOF=ZHC)
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PTC_ROOF=ZTC)
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PD_ROOF =ZD )
  ELSE
    CALL ALLOCATE_THERMAL_WORK(NDATA_ROOF_LAYER)
    DO JLAYER=1,NDATA_ROOF_LAYER
      CALL AV_PGD (ZHC(:,JLAYER), PCOVER, XDATA_HC_ROOF (:,JLAYER),YAREA,YAVG)
      CALL AV_PGD (ZTC(:,JLAYER), PCOVER ,XDATA_TC_ROOF (:,JLAYER),YAREA,YAVG)
      CALL AV_PGD (ZD (:,JLAYER), PCOVER ,XDATA_D_ROOF  (:,JLAYER),YAREA,YAVG)
    ENDDO
  ENDIF  
  CALL THERMAL_LAYERS_CONF('ROOF ',ZHC,ZTC,ZD,PHC_ROOF,PTC_ROOF,PD_ROOF)
  CALL DEALLOCATE_THERMAL_WORK
ENDIF
!
!      ALB_ROAD
!      ----------
IF (PRESENT(PALB_ROAD)) THEN 
  IF (LDATA_ALB_ROAD) THEN
    PALB_ROAD=XPAR_ALB_ROAD
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PALB_ROAD=PALB_ROAD)
  ELSE
    CALL AV_PGD (PALB_ROAD ,PCOVER ,XDATA_ALB_ROAD (:),'STR','ARI')  
  ENDIF  
ENDIF
!
!      EMIS_ROAD
!      ----------
IF (PRESENT(PEMIS_ROAD)) THEN 
  IF (LDATA_EMIS_ROAD) THEN
    PEMIS_ROAD=XPAR_EMIS_ROAD
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PEMIS_ROAD=PEMIS_ROAD)
  ELSE
    CALL AV_PGD (PEMIS_ROAD ,PCOVER ,XDATA_EMIS_ROAD (:),'STR','ARI')  
  ENDIF  
ENDIF
!
!      HC_ROAD, TC_ROAD, D_ROAD
!      ------------------------
!
IF (PRESENT(PHC_ROAD) .AND. PRESENT(PTC_ROAD) .AND. PRESENT(PD_ROAD)) THEN
  IF (LDATA_HC_ROAD) THEN
    CALL ALLOCATE_THERMAL_WORK(NPAR_ROAD_LAYER)
    ZHC=XPAR_HC_ROAD
    ZTC=XPAR_TC_ROAD
    ZD =XPAR_D_ROAD
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL ALLOCATE_THERMAL_WORK(NDESC_ROAD_LAYER)
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PHC_ROAD=ZHC)
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PTC_ROAD=ZTC)
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PD_ROAD =ZD )
  ELSE
    CALL ALLOCATE_THERMAL_WORK(NDATA_ROAD_LAYER)
    DO JLAYER=1,NDATA_ROAD_LAYER
      CALL AV_PGD (ZHC(:,JLAYER), PCOVER, XDATA_HC_ROAD (:,JLAYER),YAREA,YAVG)
      CALL AV_PGD (ZTC(:,JLAYER), PCOVER ,XDATA_TC_ROAD (:,JLAYER),YAREA,YAVG)
      CALL AV_PGD (ZD (:,JLAYER), PCOVER ,XDATA_D_ROAD  (:,JLAYER),YAREA,YAVG)
      !CALL AV_PGD (PHC_ROAD(:,JLAYER), PCOVER, XDATA_HC_ROAD (:,JLAYER),YAREA,YAVG)
      !CALL AV_PGD (PTC_ROAD(:,JLAYER), PCOVER ,XDATA_TC_ROAD (:,JLAYER),YAREA,YAVG)
      !CALL AV_PGD (PD_ROAD(:,JLAYER), PCOVER ,XDATA_D_ROAD  (:,JLAYER),YAREA,YAVG)
    ENDDO
  ENDIF  
  CALL THERMAL_LAYERS_CONF('ROAD ',ZHC,ZTC,ZD,PHC_ROAD,PTC_ROAD,PD_ROAD)
  CALL DEALLOCATE_THERMAL_WORK
ENDIF
!
!      ALB_WALL
!      ----------
IF (PRESENT(PALB_WALL)) THEN
  IF (LDATA_ALB_WALL) THEN
    PALB_WALL=XPAR_ALB_WALL
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PALB_WALL=PALB_WALL)
  ELSE
    CALL AV_PGD (PALB_WALL ,PCOVER ,XDATA_ALB_WALL (:),YAREA,YAVG)  
  ENDIF  
ENDIF
!
!      EMIS_WALL
!      ----------
IF (PRESENT(PEMIS_WALL)) THEN
  IF (LDATA_EMIS_WALL) THEN
    PEMIS_WALL=XPAR_EMIS_WALL
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PEMIS_WALL=PEMIS_WALL)
  ELSE
    CALL AV_PGD (PEMIS_WALL ,PCOVER ,XDATA_EMIS_WALL (:),YAREA,YAVG)  
  ENDIF  
ENDIF
!
!      HC_WALL, TC_WALL, D_WALL
!      ------------------------
!
IF (PRESENT(PHC_WALL) .AND. PRESENT(PTC_WALL) .AND. PRESENT(PD_WALL)) THEN
  IF (LDATA_HC_WALL) THEN
    CALL ALLOCATE_THERMAL_WORK(NPAR_WALL_LAYER)
    ZHC=XPAR_HC_WALL
    ZTC=XPAR_TC_WALL
    ZD =XPAR_D_WALL
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL ALLOCATE_THERMAL_WORK(NDESC_WALL_LAYER)
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PHC_WALL=ZHC)
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PTC_WALL=ZTC)
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PD_WALL =ZD )
  ELSE
    CALL ALLOCATE_THERMAL_WORK(NDATA_WALL_LAYER)
    DO JLAYER=1,NDATA_WALL_LAYER
      CALL AV_PGD (ZHC(:,JLAYER), PCOVER, XDATA_HC_WALL (:,JLAYER),YAREA,YAVG)
      CALL AV_PGD (ZTC(:,JLAYER), PCOVER ,XDATA_TC_WALL (:,JLAYER),YAREA,YAVG)
      CALL AV_PGD (ZD (:,JLAYER), PCOVER ,XDATA_D_WALL  (:,JLAYER),YAREA,YAVG)
    ENDDO
  ENDIF  
  CALL THERMAL_LAYERS_CONF('WALL ',ZHC,ZTC,ZD,PHC_WALL,PTC_WALL,PD_WALL)
  CALL DEALLOCATE_THERMAL_WORK
ENDIF
!
!      HC_FLOOR, TC_FLOOR, D_FLOOR
!      ------------------------
!
IF (PRESENT(PHC_FLOOR) .AND. PRESENT(PTC_FLOOR) .AND. PRESENT(PD_FLOOR)) THEN
  IF (LDATA_HC_FLOOR) THEN
    CALL ALLOCATE_THERMAL_WORK(NPAR_FLOOR_LAYER)
    ZHC=XPAR_HC_FLOOR
    ZTC=XPAR_TC_FLOOR
    ZD =XPAR_D_FLOOR
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL ALLOCATE_THERMAL_WORK(NDESC_FLOOR_LAYER)
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PHC_FLOOR=ZHC)
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PTC_FLOOR=ZTC)
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PD_FLOOR =ZD )
  ELSE
    CALL ALLOCATE_THERMAL_WORK(NDATA_FLOOR_LAYER)
    DO JLAYER=1,NDATA_FLOOR_LAYER
      CALL AV_PGD (ZHC(:,JLAYER), PCOVER, XDATA_HC_FLOOR (:,JLAYER),YAREA,YAVG)
      CALL AV_PGD (ZTC(:,JLAYER), PCOVER ,XDATA_TC_FLOOR (:,JLAYER),YAREA,YAVG)
      CALL AV_PGD (ZD (:,JLAYER), PCOVER ,XDATA_D_FLOOR  (:,JLAYER),YAREA,YAVG)
    ENDDO
  ENDIF  
  CALL THERMAL_LAYERS_CONF('FLOOR',ZHC,ZTC,ZD,PHC_FLOOR,PTC_FLOOR,PD_FLOOR)
  CALL DEALLOCATE_THERMAL_WORK
ENDIF
!
!     H_TRAFFIC
!     ---------
IF (PRESENT(PH_TRAFFIC)) THEN
  IF (LDATA_H_TRAFFIC) THEN
    PH_TRAFFIC=XPAR_H_TRAFFIC
  ELSE
    CALL AV_PGD (PH_TRAFFIC ,PCOVER ,XDATA_H_TRAFFIC(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     LE_TRAFFIC
!     ----------
IF (PRESENT(PLE_TRAFFIC)) THEN
  IF (LDATA_LE_TRAFFIC) THEN
    PLE_TRAFFIC=XPAR_LE_TRAFFIC
  ELSE
    CALL AV_PGD (PLE_TRAFFIC ,PCOVER ,XDATA_LE_TRAFFIC(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     H_INDUSTRY
!     ----------
IF (PRESENT(PH_INDUSTRY)) THEN
  IF (LDATA_H_INDUSTRY) THEN
    PH_INDUSTRY=XPAR_H_INDUSTRY
  ELSE
    CALL AV_PGD (PH_INDUSTRY ,PCOVER ,XDATA_H_INDUSTRY(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     LE_INDUSTRY
!     -----------
IF (PRESENT(PLE_INDUSTRY)) THEN
  IF (LDATA_LE_INDUSTRY) THEN
    PLE_INDUSTRY=XPAR_LE_INDUSTRY
  ELSE
    CALL AV_PGD (PLE_INDUSTRY ,PCOVER ,XDATA_LE_INDUSTRY(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     TCOOL_TARGET
!     -----------
IF (PRESENT(PTCOOL_TARGET)) THEN
  IF (LDATA_TCOOL_TARGET) THEN
    PTCOOL_TARGET=XPAR_TCOOL_TARGET
  ELSEIF (LDATA_USETYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_USETYPE,PTCOOL_TARGET=PTCOOL_TARGET)
  ELSE
    CALL AV_PGD (PTCOOL_TARGET ,PCOVER ,XDATA_TCOOL_TARGET(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     THEAT_TARGET
!     -----------
IF (PRESENT(PTHEAT_TARGET)) THEN
  IF (LDATA_THEAT_TARGET) THEN
    PTHEAT_TARGET=XPAR_THEAT_TARGET
  ELSEIF (LDATA_USETYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_USETYPE,PTHEAT_TARGET=PTHEAT_TARGET)
  ELSE
    CALL AV_PGD (PTHEAT_TARGET ,PCOVER ,XDATA_THEAT_TARGET(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     -----------
IF (PRESENT(PF_WASTE_CAN)) THEN
  IF (LDATA_F_WASTE_CAN) THEN
    PF_WASTE_CAN=XPAR_F_WASTE_CAN
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PF_WASTE_CAN=PF_WASTE_CAN)
  ELSE
    CALL AV_PGD (PF_WASTE_CAN ,PCOVER ,XDATA_F_WASTE_CAN(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     EFF_HEAT
!     -----------
IF (PRESENT(PEFF_HEAT)) THEN
  IF (LDATA_EFF_HEAT) THEN
    PEFF_HEAT=XPAR_EFF_HEAT
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PEFF_HEAT=PEFF_HEAT)
  ELSE
    CALL AV_PGD (PEFF_HEAT ,PCOVER ,XDATA_EFF_HEAT(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     QIN
!     -----------
IF (PRESENT(PQIN)) THEN
  IF (LDATA_QIN) THEN
    PQIN=XPAR_QIN
  ELSEIF (LDATA_USETYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_USETYPE,PQIN=PQIN)
  ELSE
    CALL AV_PGD (PQIN ,PCOVER ,XDATA_QIN(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     QIN_FRAD
!     -----------
IF (PRESENT(PQIN_FRAD)) THEN
  IF (LDATA_QIN_FRAD) THEN
    PQIN_FRAD=XPAR_QIN_FRAD
  ELSEIF (LDATA_USETYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_USETYPE,PQIN_FRAD=PQIN_FRAD)
  ELSE
    CALL AV_PGD (PQIN_FRAD ,PCOVER ,XDATA_QIN_FRAD(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     SHGC
!     -----------
IF (PRESENT(PSHGC)) THEN
  IF (LDATA_SHGC) THEN
    PSHGC=XPAR_SHGC
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PSHGC=PSHGC)
  ELSE
    CALL AV_PGD (PSHGC ,PCOVER ,XDATA_SHGC(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     U_WIN
!     -----------
IF (PRESENT(PU_WIN)) THEN
  IF (LDATA_U_WIN) THEN
    PU_WIN=XPAR_U_WIN
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PU_WIN=PU_WIN)
  ELSE
    CALL AV_PGD (PU_WIN ,PCOVER ,XDATA_U_WIN(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     GR
!     -----------
IF (PRESENT(PGR)) THEN
  IF (LDATA_GR) THEN
    PGR=XPAR_GR
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PGR=PGR)
  ELSE
    CALL AV_PGD (PGR ,PCOVER ,XDATA_GR(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     SHGC_SH
!     -----------
IF (PRESENT(PSHGC_SH)) THEN
  IF (LDATA_SHGC_SH) THEN
    PSHGC_SH=XPAR_SHGC_SH
  ELSEIF (LDATA_USETYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_USETYPE,PSHGC_SH=PSHGC_SH)
  ELSE
    CALL AV_PGD (PSHGC_SH ,PCOVER ,XDATA_SHGC_SH(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     FLOOR_HEIGHT
!     -----------
IF (PRESENT(PFLOOR_HEIGHT)) THEN
  IF (LDATA_FLOOR_HEIGHT) THEN
    PFLOOR_HEIGHT=XPAR_FLOOR_HEIGHT
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PFLOOR_HEIGHT=PFLOOR_HEIGHT)
  ELSE
    CALL AV_PGD (PFLOOR_HEIGHT ,PCOVER ,XDATA_FLOOR_HEIGHT(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     INF
!     -----------
IF (PRESENT(PINF)) THEN
  IF (LDATA_INF) THEN
    PINF=XPAR_INF
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PINF=PINF)
  ELSE
    CALL AV_PGD (PINF ,PCOVER ,XDATA_INF(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     F_WATER_COND
!     -----------
IF (PRESENT(PF_WATER_COND)) THEN
  IF (LDATA_F_WATER_COND) THEN
    PF_WATER_COND=XPAR_F_WATER_COND
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PF_WATER_COND=PF_WATER_COND)
  ELSE
    CALL AV_PGD (PF_WATER_COND ,PCOVER ,XDATA_F_WATER_COND(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     QIN_FLAT
!     -----------
IF (PRESENT(PQIN_FLAT)) THEN
  IF (LDATA_QIN_FLAT) THEN
    PQIN_FLAT=XPAR_QIN_FLAT
  ELSEIF (LDATA_USETYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_USETYPE,PQIN_FLAT=PQIN_FLAT)
  ELSE
    CALL AV_PGD (PQIN_FLAT ,PCOVER ,XDATA_QIN_FLAT(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     HR_TARGET
!     -----------
IF (PRESENT(PHR_TARGET)) THEN
  IF (LDATA_HR_TARGET) THEN
    PHR_TARGET=XPAR_HR_TARGET
  ELSEIF (LDATA_USETYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_USETYPE,PHR_TARGET=PHR_TARGET)
  ELSE
    CALL AV_PGD (PHR_TARGET ,PCOVER ,XDATA_HR_TARGET(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     V_VENT
!     -----------
IF (PRESENT(PV_VENT)) THEN
  IF (LDATA_V_VENT) THEN
    PV_VENT=XPAR_V_VENT
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PV_VENT=PV_VENT)
  ELSE
    CALL AV_PGD (PV_VENT ,PCOVER ,XDATA_V_VENT(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     CAP_SYS_HEAT
!     -----------
IF (PRESENT(PCAP_SYS_HEAT)) THEN
  IF (LDATA_CAP_SYS_HEAT) THEN
    PCAP_SYS_HEAT=XPAR_CAP_SYS_HEAT
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PCAP_SYS_HEAT=PCAP_SYS_HEAT)
  ELSE
    CALL AV_PGD (PCAP_SYS_HEAT ,PCOVER ,XDATA_CAP_SYS_HEAT(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     CAP_SYS_RAT
!     -----------
IF (PRESENT(PCAP_SYS_RAT)) THEN
  IF (LDATA_CAP_SYS_RAT) THEN
    PCAP_SYS_RAT=XPAR_CAP_SYS_RAT
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PCAP_SYS_RAT=PCAP_SYS_RAT)
  ELSE
    CALL AV_PGD (PCAP_SYS_RAT ,PCOVER ,XDATA_CAP_SYS_RAT(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     T_ADP
!     -----------
IF (PRESENT(PT_ADP)) THEN
  IF (LDATA_T_ADP) THEN
    PT_ADP=XPAR_T_ADP
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PT_ADP=PT_ADP)
  ELSE
    CALL AV_PGD (PT_ADP ,PCOVER ,XDATA_T_ADP(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     M_SYS_RAT
!     -----------
IF (PRESENT(PM_SYS_RAT)) THEN
  IF (LDATA_M_SYS_RAT) THEN
    PM_SYS_RAT=XPAR_M_SYS_RAT
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PM_SYS_RAT=PM_SYS_RAT)
  ELSE
    CALL AV_PGD (PM_SYS_RAT ,PCOVER ,XDATA_M_SYS_RAT(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     COP_RAT
!     -----------
IF (PRESENT(PCOP_RAT)) THEN
  IF (LDATA_COP_RAT) THEN
    PCOP_RAT=XPAR_COP_RAT
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PCOP_RAT=PCOP_RAT)
  ELSE
    CALL AV_PGD (PCOP_RAT ,PCOVER ,XDATA_COP_RAT(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     GREENROOF FRACTION
!     ------------------
IF (PRESENT(PGREENROOF)) THEN
  IF (LDATA_GREENROOF) THEN
    PGREENROOF=XPAR_GREENROOF
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PGREENROOF=PGREENROOF)
  ELSE
    CALL AV_PGD (PGREENROOF,PCOVER ,XDATA_FRAC_GR(:),'BLD','ARI')
  ENDIF  
ENDIF
!
!     T_SIZE_MAX
!     -----------
IF (PRESENT(PT_SIZE_MAX)) THEN
  IF (LDATA_T_SIZE_MAX) THEN
    PT_SIZE_MAX=XPAR_T_SIZE_MAX
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PT_SIZE_MAX=PT_SIZE_MAX)
  ELSE
    CALL AV_PGD (PT_SIZE_MAX ,PCOVER ,XDATA_T_SIZE_MAX(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     T_SIZE_MIN
!     -----------
IF (PRESENT(PT_SIZE_MIN)) THEN
  IF (LDATA_T_SIZE_MIN) THEN
    PT_SIZE_MIN=XPAR_T_SIZE_MIN
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PT_SIZE_MIN=PT_SIZE_MIN)
  ELSE
    CALL AV_PGD (PT_SIZE_MIN ,PCOVER ,XDATA_T_SIZE_MIN(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     SHADE
!     -----
IF (PRESENT(PSHADE)) THEN
  IF (LDATA_SHADE) THEN
    PSHADE(:) = XPAR_SHADE(:)
  ELSEIF (LDATA_USETYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_USETYPE,PSHADE=PSHADE)
  ELSE
    CALL AV_PGD (PSHADE,PCOVER ,XDATA_SHADE(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!     NATVENT
!     -------
IF (PRESENT(PNATVENT)) THEN
  IF (LDATA_NATVENT) THEN
    PNATVENT(:) = XPAR_NATVENT(:)
  ELSEIF (LDATA_USETYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_USETYPE,PNATVENT=PNATVENT)
  ELSE
    CALL AV_PGD (PNATVENT,PCOVER,XDATA_NATVENT(:),'TWN','ARI')
  ENDIF  
ENDIF
!
!
!      ROUGH_ROOF
!      ----------
IF (PRESENT(PROUGH_ROOF)) THEN 
  IF (LDATA_ROUGH_ROOF) THEN
    PROUGH_ROOF=XPAR_ROUGH_ROOF
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PROUGH_ROOF=PROUGH_ROOF)
  ELSE
    CALL AV_PGD (PROUGH_ROOF ,PCOVER ,XDATA_ROUGH_ROOF (:),YAREA,YAVG)  
  ENDIF  
ENDIF
!
!      ROUGH_WALL
!      ----------
IF (PRESENT(PROUGH_WALL)) THEN 
  IF (LDATA_ROUGH_WALL) THEN
    PROUGH_WALL=XPAR_ROUGH_WALL
  ELSEIF (LDATA_BLDTYPE) THEN
    CALL INI_DATA_PARAM_TEB(NPAR_BLDCODE,PROUGH_WALL=PROUGH_WALL)
  ELSE
    CALL AV_PGD (PROUGH_WALL ,PCOVER ,XDATA_ROUGH_WALL (:),YAREA,YAVG)  
  ENDIF  
ENDIF
! 
!
IF (LHOOK) CALL DR_HOOK('CONVERT_PATCH_TEB',1,ZHOOK_HANDLE)
!
!-------------------------------------------------------------------------------
CONTAINS
!
SUBROUTINE ALLOCATE_THERMAL_WORK(KPAR)
INTEGER, INTENT(IN) :: KPAR
ALLOCATE(ZD(IL,KPAR))
ALLOCATE(ZHC(IL,KPAR))
ALLOCATE(ZTC(IL,KPAR))
END SUBROUTINE ALLOCATE_THERMAL_WORK
SUBROUTINE DEALLOCATE_THERMAL_WORK
DEALLOCATE(ZD)
DEALLOCATE(ZHC)
DEALLOCATE(ZTC)
END SUBROUTINE DEALLOCATE_THERMAL_WORK
!-------------------------------------------------------------------------------
!
END SUBROUTINE CONVERT_PATCH_TEB
